﻿Public Class Form1
    Private Const PriceGap As Integer = 500
    Private isStart As Boolean
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Initialize values on load
        isStart = True
        ActiveControl = Label1
        MinTextBox.Text = "2500"
        MaxTextBox.Text = "8500"
        MinTrackBar.Minimum = 0
        MinTrackBar.Maximum = 10000
        MinTrackBar.Value = 2500
        MaxTrackBar.Minimum = 0
        MaxTrackBar.Maximum = 10000
        MaxTrackBar.Value = 8500
        isStart = False

        ' Update the visual representation of the slider
        UpdateSlider()
    End Sub

    Private Sub MinTextBox_TextChanged(sender As Object, e As EventArgs) Handles MinTextBox.TextChanged
        If isStart = True Then
            Exit Sub
        End If
        Dim minPrice As Integer
        If Integer.TryParse(MinTextBox.Text, minPrice) AndAlso minPrice >= 0 Then
            If minPrice > MaxTrackBar.Value - PriceGap Then
                minPrice = MaxTrackBar.Value - PriceGap
                MinTextBox.Text = minPrice.ToString()
            End If
            MinTrackBar.Value = minPrice
            UpdateSlider()
        End If
    End Sub

    Private Sub MaxTextBox_TextChanged(sender As Object, e As EventArgs) Handles MaxTextBox.TextChanged
        If isStart = True Then
            Exit Sub
        End If
        Dim maxPrice As Integer
        If Integer.TryParse(MaxTextBox.Text, maxPrice) AndAlso maxPrice <= 10000 Then
            If maxPrice < MinTrackBar.Value + PriceGap Then
                maxPrice = MinTrackBar.Value + PriceGap
                MaxTextBox.Text = maxPrice.ToString()
            End If
            MaxTrackBar.Value = maxPrice
            UpdateSlider()
        End If
    End Sub

    Private Sub MinTrackBar_Scroll(sender As Object, e As EventArgs) Handles MinTrackBar.Scroll
        If isStart = True Then
            Exit Sub
        End If
        MinTextBox.Text = MinTrackBar.Value.ToString()
        If MinTrackBar.Value > MaxTrackBar.Value - PriceGap Then
            MinTrackBar.Value = MaxTrackBar.Value - PriceGap
            MinTextBox.Text = MinTrackBar.Value.ToString()
        End If
        UpdateSlider()
    End Sub

    Private Sub MaxTrackBar_Scroll(sender As Object, e As EventArgs) Handles MaxTrackBar.Scroll
        If isStart = True Then
            Exit Sub
        End If
        MaxTextBox.Text = MaxTrackBar.Value.ToString()
        If MaxTrackBar.Value < MinTrackBar.Value + PriceGap Then
            MaxTrackBar.Value = MinTrackBar.Value + PriceGap
            MaxTextBox.Text = MaxTrackBar.Value.ToString()
        End If
        UpdateSlider()
    End Sub

    Private Sub UpdateSlider()
        If isStart = True Then
            Exit Sub
        End If
        Dim panelWidth As Integer = SliderPanel.Width
        Dim minPos As Integer = MinTrackBar.Value / 10000 * panelWidth
        Dim maxPos As Integer = MaxTrackBar.Value / 10000 * panelWidth
        PriceSlider.Location = New Point(minPos, PriceSlider.Location.Y)
        PriceSlider.Width = maxPos - minPos
    End Sub
End Class
